<template>
  <div class="main-board-container" @click="closeModal">
    <h1>Доска задач</h1>
    <h2
        v-for="(board, index) in boards"
        @click="chooseBoard(board)"
        :key="index"
    >
      Доска номер {{ board }}
    </h2>
    <div v-if="board.tasks" class="board-container">
      <div class="board-column">
        <p>In work</p>
        <div class="tasks">
          <Task
              @clicked="changeVisible"
              :id="task.id"
              v-for="task in Object.values(board.tasks)"
              :key="task.id"
              :status="task.status"
              :filter="'In work'"
              :task="task"
          />
        </div>
      </div>
      <div class="board-column">
        <p>Review</p>
        <div class="tasks">
          <Task
              @clicked="changeVisible"
              :id="task.id"
              v-for="task in Object.values(board.tasks)"
              :key="task.id"
              :status="task.status"
              :filter="'Review'"
              :task="task"
          />
        </div>
      </div>
      <div class="board-column">
        <p>Test</p>
        <div class="tasks">
          <Task
              @clicked="changeVisible"
              :id="task.id"
              v-for="task in Object.values(board.tasks)"
              :key="task.id"
              :status="task.status"
              :filter="'Test'"
              :task="task"
          />
        </div>
      </div>
      <div class="board-column">
        <p>Done</p>
        <div class="tasks">
          <Task
              @clicked="changeVisible"
              :id="task.id"
              v-for="task in Object.values(board.tasks)"
              :key="task.id"
              :status="task.status"
              :filter="'Done'"
              :task="task"
          />
        </div>
      </div>
    </div>
    <TaskModal
        @close-modal="closeModalImmediately"
        v-if="opened"
        :class="classes"
    />
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";

export default {
  name: "Board",
  data() {
    return {
      opened: false,
    };
  },
  components: {
    Task: () => import("@/components/Task"),
    TaskModal: () => import("@/components/TaskModal"),
  },
  methods: {
    ...mapActions(["getBoard"]),
    changeVisible() {
      this.opened = true;
      window.addEventListener("click", this.closeModal);
    },
    async chooseBoard(board) {
      await this.$router.push(`/board/${board}`);
      await this.getBoard(board);
    },
    checkNodes(node) {
      let domElements = {};
      const recursiveNodes = (node) => {
        domElements[node.className] = true;
        if (node.parentElement.className) {
          recursiveNodes(node.parentElement);
        }
      };
      recursiveNodes(node);
      return (
          domElements["container task-modal"] ||
          domElements["single-task"] ||
          domElements["dropdown-item"]
      );
    },
    closeModalImmediately() {
      this.opened = false;
      this.$router.push(`/board/${this.$route.params.board_id}`);
    },
    closeModal(e) {
      if (this.checkNodes(e.target)) {
        this.opened = true;
      } else {
        if (this.$route.path !== `/board/${this.$route.params.board_id}`) {
          this.$router.push(`/board/${this.$route.params.board_id}`);
        }
        this.opened = false;
      }
    },
  },
  computed: {
    ...mapGetters({board: "getBoard", boards: "getBoards"}),
    classes() {
      return {'task-modal': true, 'invisible': !this.opened}
    }
  },
};
</script>

<style scoped>
.main-board-container {
  justify-content: flex-start;
  display: flex;
  flex-direction: column;
}

.board-container {
  display: flex;
  justify-content: space-around;
  width: 100%;
}

.invisible {
  display: none;
}

.task-modal {
  position: fixed;
  left: 0;
  top: 0;
  bottom: 0;
  right: 0;
  margin: auto;
}
</style>
